import 'dart:convert';

class HereAddress {
  String? Label;
  String? Country;
  String? CountryCode;
  String? State;
  String? County;
  String? City;
  String? District;
  String? Subdistrict;
  String? Street;
  String? HouseNumber;
  String? PostalCode;

  HereAddress({
    this.Label,
    this.Country,
    this.CountryCode,
    this.State,
    this.County,
    this.City,
    this.District,
    this.Subdistrict,
    this.Street,
    this.HouseNumber,
    this.PostalCode,
  });

  HereAddress copyWith({
    String? Label,
    String? Country,
    String? CountryCode,
    String? State,
    String? County,
    String? City,
    String? District,
    String? Subdistrict,
    String? Street,
    String? HouseNumber,
    String? PostalCode,
  }) {
    return HereAddress(
      Label: Label ?? this.Label,
      Country: Country ?? this.Country,
      CountryCode: CountryCode ?? this.CountryCode,
      State: State ?? this.State,
      County: County ?? this.County,
      City: City ?? this.City,
      District: District ?? this.District,
      Subdistrict: Subdistrict ?? this.Subdistrict,
      Street: Street ?? this.Street,
      HouseNumber: HouseNumber ?? this.HouseNumber,
      PostalCode: PostalCode ?? this.PostalCode,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'Label': Label,
      'Country': Country,
      'CountryCode': CountryCode,
      'State': State,
      'County': County,
      'City': City,
      'District': District,
      'Subdistrict': Subdistrict,
      'Street': Street,
      'HouseNumber': HouseNumber,
      'PostalCode': PostalCode,
    };
  }

  factory HereAddress.fromMap(Map<String, dynamic> map) {
    return HereAddress(
      Label: map['Label'],
      Country: map['Country'],
      CountryCode: map['CountryCode'],
      State: map['State'],
      County: map['County'],
      City: map['City'],
      District: map['District'],
      Subdistrict: map['Subdistrict'],
      Street: map['Street'],
      HouseNumber: map['HouseNumber'],
      PostalCode: map['PostalCode'],
    );
  }

  String toJson() => json.encode(toMap());

  factory HereAddress.fromJson(String source) => HereAddress.fromMap(json.decode(source));

  @override
  String toString() {
    return 'HereAddress(Label: $Label, Country: $Country, CountryCode: $CountryCode, State: $State, County: $County, City: $City, District: $District, Subdistrict: $Subdistrict, Street: $Street, HouseNumber: $HouseNumber, PostalCode: $PostalCode)';
  }

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;

    return other is HereAddress &&
        other.Label == Label &&
        other.Country == Country &&
        other.CountryCode == CountryCode &&
        other.State == State &&
        other.County == County &&
        other.City == City &&
        other.District == District &&
        other.Subdistrict == Subdistrict &&
        other.Street == Street &&
        other.HouseNumber == HouseNumber &&
        other.PostalCode == PostalCode;
  }

  @override
  int get hashCode {
    return Label.hashCode ^
        Country.hashCode ^
        CountryCode.hashCode ^
        State.hashCode ^
        County.hashCode ^
        City.hashCode ^
        District.hashCode ^
        Subdistrict.hashCode ^
        Street.hashCode ^
        HouseNumber.hashCode ^
        PostalCode.hashCode;
  }
}
