import 'HereLocation.dart';
import 'HereMatchQuality.dart';

class HereViewResult {
  late double relevance;
  late String matchLevel;
  late HereMatchQuality matchQuality;
  late HereLocation location;

  HereViewResult(
      {required this.relevance, required this.matchLevel, required this.matchQuality, required this.location});

  HereViewResult.fromJson(Map<String, dynamic> json) {
    relevance = json['Relevance'] as double;
    matchLevel = json['MatchLevel'] as String;
    matchQuality = HereMatchQuality.fromJson(json['MatchQuality']);
    location = HereLocation.fromJson(json['Location']);
    // matchQuality = json['MatchQuality'] != null ? new MatchQuality.fromJson(json['MatchQuality']) : null;
    // location = json['Location'] != null ? new Location.fromJson(json['Location']) : null;
  }

  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['Relevance'] = relevance;
    data['MatchLevel'] = matchLevel;
    data['MatchQuality'] = matchQuality.toJson();
    data['Location'] = location.toJson();
    return data;
  }
}
